/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#include "ServiceMutexThread.h"
#include "MixCast.h"

FServiceMutexThread::FServiceMutexThread()
{
	serviceMutex = CreateMutex(NULL, false, L"Global\\MixCast#Running");
	stopEvent = CreateEvent(NULL, true, false, NULL);

	thread = FRunnableThread::Create(this, TEXT("MixCast Service Check"), 0, TPri_BelowNormal);
}

FServiceMutexThread::~FServiceMutexThread()
{
	thread->Kill(true);
	delete thread;
	thread = NULL;

	CloseHandle(serviceMutex);
	CloseHandle(stopEvent);
}

uint32 FServiceMutexThread::Run()
{
	HANDLE events[2] {
		stopEvent,
		serviceMutex,
	};

	DWORD res = WaitForMultipleObjects(2, events, false, INFINITE);
	if (res == WAIT_OBJECT_0)
		return 0;

	ReleaseMutex(serviceMutex);

	AsyncTask(ENamedThreads::GameThread, [&]()
	{
		((FMixCast*)&IMixCast::Get())->SetActive(false);
	});

	return 0;
}

void FServiceMutexThread::Stop()
{
	SetEvent(stopEvent);
}
